ArenaMaster = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
local L = AceLibrary("AceLocale-2.2"):new("ArenaMaster")
local tablet = AceLibrary("Tablet-2.0")



local options = { 
    type="group",
    args = {
    	save= {
    		type="execute",
    		name="Save",
    		desc="Save visual options",
    		func="SaveVisual",
    		},
		detach= {
			type="toggle",
			name="Detach",
			desc="Show main frame",
			set=function() if tablet:IsAttached("ArenaMaster") then	ArenaMaster:ShowAM() else ArenaMaster:HideAM() end end,
			get=function() return not tablet:IsAttached("ArenaMaster") end,	
			}
		}
}


ArenaMaster:RegisterChatCommand({"/arenamaster", "/am"}, options)



function ArenaMaster:OnInitialize()
	self.tabletframename=""
	self.list = {}
	self.livelist={}
	self.livelistclass={}
	self.liveliststatus={}
	self.zoneCheck=false
	self.prefixAM="ArenaMaster"
	self.targetframes={}
  self:ResetList()
  self.zoneCheck=false
  ArenaMaster:RegisterDB("ArenaMasterDB")
	ArenaMaster:RegisterDefaults("profile", {
		params = {
			fontSizePercent=1, 
			detached=true, 
			transparency=0.9,
			r=0,
			g=0,
			b=0,
			}
		}
	)   	
end

function ArenaMaster:SaveVisual()
	if tablet:IsAttached("ArenaMaster") then
		ArenaMaster:ShowAM()
	end
	self.db.profile.params["fontSizePercent"]=(tablet:GetFontSizePercent("ArenaMaster"))
	self.db.profile.params["detached"]= (not tablet:IsAttached("ArenaMaster"))
	self.db.profile.params["transparency"]=(tablet:GetTransparency("ArenaMaster"))
	self.db.profile.params.r,self.db.profile.params.g,self.db.profile.params.b=(tablet:GetColor("ArenaMaster"))
	ArenaMaster:HideAM()
end

function ArenaMaster:OnDisable()
	self:ResetList()
	self:SaveVisual()
end



function ArenaMaster:OnTooltipUpdate()
        local cat = tablet:AddCategory("child_justify", "CENTER")
        for i=1,table.getn(self.livelist) do
            local name=self.livelist[i]
            local class=self.livelistclass[i]
						local color=self:GetColor(class)
            if self.liveliststatus[i]==0 then color=self:GetColor("dead") end
            local class=L:GetTranslation(class)
            if self.liveliststatus[i]==-1 then 
        			cat:AddLine("text", color..class.." ** FD ** ("..name..")|r", 'justify', "LEFT","func", function()
								if self.liveliststatus[i]>0 then SendChatMessage("ArenaMaster :: Class: "..class.."   Name: "..name.."   HP: "..self.liveliststatus[i].."%", "BATTLEGROUND")
								elseif self.liveliststatus[i]==0 then SendChatMessage("ArenaMaster :: Class: "..class.."   Name: "..name.."   **DEAD**", "BATTLEGROUND") 
								else SendChatMessage("ArenaMaster :: Class: "..class.."   Name: "..name.."   **FEIGN DEATH**", "BATTLEGROUND") end
							end
							)
						else
							cat:AddLine("text", color..class.." ("..name..") "..self.liveliststatus[i].."%|r", 'justify', "LEFT", "func", 
								function()
								if self.liveliststatus[i]>0 then SendChatMessage("ArenaMaster :: Class: "..class.."   Name: "..name.."   HP: "..self.liveliststatus[i].."%", "BATTLEGROUND")
								elseif self.liveliststatus[i]==0 then SendChatMessage("ArenaMaster :: Class: "..class.."   Name: "..name.."   **DEAD**", "BATTLEGROUND") 
								else SendChatMessage("ArenaMaster :: Class: "..class.."   Name: "..name.."   **FEIGN DEATH**", "BATTLEGROUND") end
							end 
							)
						end
        end
        if table.getn(self.livelist) == 5 then return end
        for i=table.getn(self.livelist)+1,5 do
        	cat:AddLine("text"," ", 
								function() end 
							)
        end
end

function ArenaMaster:OnEnable()
    self:ResetList()
    self.zoneCheck=false

    if not tablet:IsRegistered("ArenaMaster") then
    	tablet:Register("ArenaMaster",
    	"detachedData", self.db.profile.params,
    	"children", function()
                	tablet:SetTitle("Arena Master")
					self:OnTooltipUpdate()
					end,
    	"cantAttach", true,
    	"hideWhenEmpty", false,
    	"showTitleWhenDetached", true,
		"point", function() return "CENTER", "CENTER" end)
	end
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function ArenaMaster:PLAYER_ENTERING_WORLD()
	self.zoneCheck=false
	self:ScheduleEvent(self.ZoneCheck, 5, self)
end

function ArenaMaster:CHAT_MSG_COMBAT_HOSTILE_DEATH(msg)
  for i=1,table.getn(self.livelist) do
		if msg == string.format(UNITDIESOTHER, self.livelist[i]) then
			self.liveliststatus[i]=0
		end
   end
end

function ArenaMaster:ZoneCheck()

	self.zoneCheck=false
	self:ResetList()
 	self:RegisterEvent("CHAT_MSG_ADDON")
 	self:RegisterEvent("UNIT_HEALTH")
 	self:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")
 	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT") 
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	
	if strfind(GetMinimapZoneText(), L["Arena"]) then
		self.zoneCheck=true
		if tablet:IsAttached("ArenaMaster") then
			ArenaMaster:ShowAM()
		end
		if not self:IsEventScheduled("arenarefresh") then
		self:ScheduleRepeatingEvent("arenarefresh", function() tablet:Refresh("ArenaMaster") end, .1)
		end

	else 
	  self:UnregisterEvent("UPDATE_MOUSEOVER_UNIT")
	  self:UnregisterEvent("PLAYER_TARGET_CHANGED")
	  self:UnregisterEvent("UNIT_HEALTH")
	  self:UnregisterEvent("CHAT_MSG_ADDON")
	  self:UnregisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")
	  self:CancelScheduledEvent("arenarefresh")
	  tablet:Refresh("ArenaMaster")
		self:SaveVisual()
		if not tablet:IsAttached("ArenaMaster") then
			ArenaMaster:HideAM()
		end
	end
end


function ArenaMaster:UPDATE_MOUSEOVER_UNIT()
	if self.zoneCheck==true  then
   		if self:CheckList(UnitName("mouseover")) then 
   	 		if not UnitIsFriend("player","mouseover") then
   	 		  local class=L:GetReverseTranslation(UnitClass("mouseover"))
   	 			if (UnitCreatureType("mouseover")== L["Humanoid"] or class=="Druid" or class=="Shaman") and not strfind(UnitName("mouseover"), " ") then
   					self:AddToList(UnitName("mouseover"))
   					local name=UnitName("mouseover")
   					table.insert(self.livelist, name)
   					table.insert(self.livelistclass, class)
    				table.insert(self.liveliststatus, UnitHealth("mouseover"))
    				SendAddonMessage("ArenaMaster", name.." "..class, "BATTLEGROUND")
   				end
   			end
		elseif UnitHealth("mouseover") > 0 then self:HandleFD(UnitName("mouseover"),0,"alive",UnitHealth("mouseover"))
		elseif UnitHealth("mouseover") <= 0 and UnitDebuff("mouseover",1)~=nil and L:GetReverseTranslation(UnitClass("mouseover"))=="Hunter" then self:HandleFD(UnitName("mouseover"),0,"FD",UnitHealth("mouseover"))	
		elseif UnitHealth("mouseover") <= 0 then self:HandleFD(UnitName("target"),0,"dead",0)
		end
	end
end


function ArenaMaster:PLAYER_TARGET_CHANGED()
 if UnitName("target")~=nil then
	if self.zoneCheck==true  then
   		if self:CheckList(UnitName("target")) then 
   	 		if not UnitIsFriend("player","target") then
   	 			local class=L:GetReverseTranslation(UnitClass("target"))
   	 			if (UnitCreatureType("target")== L["Humanoid"] or class=="Druid" or class=="Shaman") and not strfind(UnitName("target"), " ") then
   					self:AddToList(UnitName("target"))
   					local name=UnitName("target")
   					table.insert(self.livelist, name)
   					table.insert(self.livelistclass, class)
    				table.insert(self.liveliststatus, UnitHealth("target"))
    				SendAddonMessage("ArenaMaster", name.." "..class, "BATTLEGROUND")
   				end
   			end
		elseif UnitHealth("target") > 0 then self:HandleFD(UnitName("target"),0,"alive",UnitHealth("target"))
		elseif UnitHealth("target") <= 0 and UnitDebuff("target",1)~=nil and L:GetReverseTranslation(UnitClass("target"))=="Hunter" then self:HandleFD(UnitName("target"),0,"FD",UnitHealth("target"))	
		elseif UnitHealth("target") <= 0 then self:HandleFD(UnitName("target"),0,"dead",0)
		end
	end
 end
end

function ArenaMaster:UNIT_HEALTH()
 if UnitName("target")~=nil and arg1=="target" then
	if self.zoneCheck==true  then
   		if self:CheckList(UnitName("target")) then 
   	 		if not UnitIsFriend("player","target") then
   	 			local class=L:GetReverseTranslation(UnitClass("target"))
   	 			if (UnitCreatureType("target")== L["Humanoid"] or class=="Druid" or class=="Shaman") and not strfind(UnitName("target"), " ") then
   					self:AddToList(UnitName("target"))
   					local name=UnitName("target")
   					table.insert(self.livelist, name)
   					table.insert(self.livelistclass, class)
    				table.insert(self.liveliststatus, UnitHealth("target"))
    				SendAddonMessage("ArenaMaster", name.." "..class, "BATTLEGROUND")
   				end
   			end
		elseif UnitHealth("target") > 0 then self:HandleFD(UnitName("target"),0,"alive",UnitHealth("target"))
		elseif UnitHealth("target") <= 0 and UnitDebuff("target",1)~=nil and L:GetReverseTranslation(UnitClass("target"))=="Hunter" then self:HandleFD(UnitName("target"),0,"FD",UnitHealth("target"))
		elseif UnitHealth("target") <= 0 then self:HandleFD(UnitName("target"),0,"dead",0)	
		end
	end
 end
end


function ArenaMaster:CHAT_MSG_ADDON()
	local prefix, message, dist, sender = arg1, arg2, arg3, arg4
	if (prefix==self.prefixAM) then
		if (sender==UnitName("player")) then return end
		if self.zoneCheck==true then
			local limit,limit2=string.find(message," ")
			if limit==nil then return end
			local name=string.sub(message,0,limit-1)
			local class=string.sub(message,limit+1)
			
			if strfind(class,"alive") then 
				local a=string.gsub(class, "alive", "")
				self:HandleFD(name,1,"alive",tonumber(a))
			elseif class=="FD" then self:HandleFD(name,1,"FD")
			elseif class=="dead" then self:HandleFD(name,1,"dead",0)
   		elseif self:CheckList(name) then
   					self:AddToList(name)
   					table.insert(self.livelist, name)
   					table.insert(self.livelistclass, class)
    				table.insert(self.liveliststatus, 100)
			end
  	 end
	end	
end

function ArenaMaster:GetColor(class)
	local temp="|cffffffff"
	if class=="Druid" then temp="|cffff7c0a" end
	if class=="Hunter" then temp="|cffaad372" end
	if class=="Mage" then temp="|cff68ccef" end
	if class=="Paladin" then temp="|cfff48cba" end
	if class=="Priest" then temp="|cffffffff" end
	if class=="Rogue" then temp="|cfffff468" end
	if class=="Shaman" then temp="|cff00dbba" end
	if class=="Warlock" then temp="|cff9382c9" end
	if class=="Warrior" then temp="|cffc69b6d" end
	if class=="dead" then temp="|cff465945" end
	return temp
end

function ArenaMaster:AddToList(name)
	table.insert(self.list, name)
	local i=table.getn(self.list)
	if InCombatLockdown() then self:ScheduleLeaveCombatAction(function() self:TargetInit(i) return end)
	else self:TargetInit(i)
	end
end

function ArenaMaster:CheckList(name)
  local result=true
	for i=1,table.getn(self.list) do
	   if self.list[i]==name then 
	  	 result=false 
	   end
	end
	return result
end


function ArenaMaster:ResetList()
	self:HideAM()
	self.list= {}
	self.livelist={}
	self.livelistclass={}
	self.liveliststatus={}
	self.targetframes={}

end

function ArenaMaster:HandleFD(name,nobroadcast,status,perc)

	if status=="alive" then
		for i=1,table.getn(self.list) do
			if self.list[i]==name then
				if self.liveliststatus[i] ~= perc then
					self.liveliststatus[i]=perc
					if nobroadcast==0 then SendAddonMessage(self.prefixAM, name.." ".."alive"..perc, "BATTLEGROUND") end
				end
			end
		end
		
		
	elseif status=="FD" then
		for i=1,table.getn(self.list) do
			if self.list[i]==name then
				if self.liveliststatus[i]>=0 then
					self.liveliststatus[i]=-1
					if nobroadcast==0 then SendAddonMessage(self.prefixAM, name.." ".."FD", "BATTLEGROUND") end
				end
			end
		end		
		
	elseif status=="dead" then
		for i=1,table.getn(self.list) do
			if self.list[i]==name then
				if self.liveliststatus[i]>0 then
					self.liveliststatus[i]=0
					if nobroadcast==0 then SendAddonMessage(self.prefixAM, name.." ".."dead", "BATTLEGROUND") end
				end
			end
		end	 
	end
end

function ArenaMaster:HideAM()
	if tablet:IsRegistered("ArenaMaster") then
	if not tablet:IsAttached("ArenaMaster") then tablet:Attach("ArenaMaster") end end
	if self.targetframes==nil then return end
	if table.getn(self.targetframes)==0 then return end
	for i=1,table.getn(self.targetframes) do
		self.targetframes[i]:Hide()
	end
end

function ArenaMaster:ShowAM()
	tablet:Detach("ArenaMaster")
	local a=0
	local frame = EnumerateFrames()
	while frame do
    if frame:IsVisible() and frame.owner=="ArenaMaster" then
        a=frame:GetName()
    end
 		frame = EnumerateFrames(frame)
  end
  self.tabletframename=a
end

function ArenaMaster:TargetInit(i)
		local f=CreateFrame("Button", "Target", UIParent, "SecureActionButtonTemplate")
		local r=self.db.profile.params.fontSizePercent
		f:SetHeight(14*r)
		f:SetWidth(14*r)
		f:RegisterForClicks("LeftButtonUp")
		f:SetAttribute("type1", "macro")
		f:SetAttribute("macrotext", "/target "..self.list[i])
		f:SetPoint("TOPRIGHT",self.tabletframename,"TOPLEFT",0,-24-6.5*r + (-5-12*r)*(i-1))
		local t = f:CreateTexture(nil,"BACKGROUND")
		t:SetTexture("Interface\\Icons\\Ability_Hunter_SniperShot.blp")
		t:SetAllPoints(f)
		f.texture = t
		table.insert( self.targetframes, f )
end
